#ifndef CONTEXTFREESERVICES_H
#define CONTEXTFREESERVICES_H

#include <QWidget>
#include "Cube.h"

class ContextFreeServices : public QObject
{
    Q_OBJECT
public:
    static ContextFreeServices*
    getInstance();

    /** closes this plugin and loads the given cube */
    void
    openCube( cube::Cube* cube );

    /** returns a widget on the main screen which can be used by the plugin. If the widget is closed, all
     * children of the widget are deleted.
     */
    QWidget*
    getWidget();

    friend class MainWidget;
signals:
    void
    openCubeRequest( cube::Cube* cube );

private:
    ContextFreeServices();
    void
    setWidget( QWidget* ); // called by MainWidget

    static ContextFreeServices* single;
    QWidget*                    widget;
};

#endif // CONTEXTFREESERVICES_H
