/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef TABINTERFACE_H
#define TABINTERFACE_H

#include <QIcon>
#include "Constants.h"
#include "Cube.h"

/**
 * @brief The TabInterface class is inherited from all widgets, which are placed in the
 * SystemTabWidget, CallTabWidget or SystemTabWidget
 */

class TabInterface
{
public:
    /** returns the widget which will be added as tab
     */
    virtual QWidget*
    widget() = 0;

    /** returns the label which is used for the tab widget
     */
    virtual QString
    label() const = 0;

    // ---- end of pure virtual functions -----------------------------------------------

    /** This method is called, if the selected tree item has changed, the tree structure
     *  has changed or if an item is expanded or collapsed */
    virtual void
    valuesChanged()
    {
    };

    /** called, if the value modus combo box has been changed */
    virtual void
    valueModusChanged( ValueModus )
    {
    };


    /** returns the icon which is displayed in the left part of the tab */
    virtual QIcon
    icon() const
    {
        return QIcon();
    }

    /** called if current Tab becomes active or inactive */
    virtual void
    setActive( bool )
    {
    }
};

#endif // TABINTERFACE_H
